%define tag .GA
%define majmin 5.1
%define namedversion %{version}%{?tag}

Name:           jbossas-tp
Version:        5.1.0
Release:        8%{?dist}
Epoch:          0
Summary:        JBoss AS Third-Party Libraries
License:        LGPLv2+
Group:          Development/Java
URL:            http://jboss.org/jbossas/
# rm -rf jboss-5.0.0-src && mkdir -p jboss-5.0.0-src/5.0.0
# svn export http://anonsvn.jboss.org/repos/jbossas/tags/JBPAPP_5_0_0/ jboss-5.0.0-src/5.0.0/jboss-5.0.x
# FIXME Using the branch tip temporarely
# svn export http://anonsvn.jboss.org/repos/jbossas/branches/JBPAPP_5_0/ jboss-5.0.0-src/5.0.0/jboss-5.0.x
# Exported revision 93624.
# tar cjf jboss-5.0.0-src.tar.bz2 jboss-5.0.0-src
#Source0:       jboss-%{version}-src.tar.bz2
Source0:        jboss-5.1.0.GA-src.tar.bz2

# Depmap to convert mismatched Maven coordinates
Source1:        jbossas-tp-depmap.xml
Source2:        jbossas-tp-settings.xml

# We need a jboss-jopr package
# org.jboss.jopr:jopr-embedded-jbas5:war:1.3.1.GA
Source13:       jbossas-tp-jopr.tgz

Source16:       jbossas-tp-seam.tgz

Source17:       jbossas-tp-licenses.tar.bz2

# Things we need to patch
Patch0:         jbossas-tp-pom.patch
Patch1:         jbossas-tp-no-download-licenses.patch

BuildArch:      noarch

Requires:       jpackage-utils

# Basic stuff
BuildRequires:  jpackage-utils
BuildRequires:  java
BuildRequires:  java-devel

# The build is driven by ant which calls maven
#BuildRequires:  ant
#BuildRequires:  ant-nodeps

# Thirdparty is created with maven
BuildRequires:  maven2
BuildRequires:  maven2-plugin-clean
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-ant-tasks
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-shared
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-shared-file-management
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  maven-surefire
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-wagon
BuildRequires:  plexus-archiver
BuildRequires:  plexus-compiler
BuildRequires:  plexus-containers-container-default
BuildRequires:  plexus-i18n
BuildRequires:  plexus-utils
BuildRequires:  plexus-velocity
# FIXME: maven-shared-dependency-analyzer is missign a Requires for asm 3.0
BuildRequires:  objectweb-asm >= 0:3.0

# JBoss AS dependencies
BuildRequires:  jakarta-taglibs-standard >= 0:1.1.2
BuildRequires:  jakarta-commons-logging-jboss >= 0:1.1
BuildRequires:  jboss-parent
BuildRequires:  maven-jboss-license-plugin
BuildRequires:  maven-buildmagic-thirdparty-plugin
BuildRequires:  jboss-cluster-ha-server-cache-spi >= 0:2.0.0
BuildRequires:  jboss-cluster-ha-client >= 0:1.1.1
BuildRequires:  glassfish-jstl >= 0:1.2
BuildRequires:  jbossts >= 0:4.6.1
BuildRequires:  jboss-aop2 >= 0:2.1.1
BuildRequires:  xdoclet >= 0:1.2.3
BuildRequires:  hibernate3 >= 0:3.3.1
BuildRequires:  jboss-deployers >= 0:2.0.7
BuildRequires:  javacc >= 0:4.0
BuildRequires:  jbossweb >= 0:2.1.3
BuildRequires:  jbossweb-el-1.0-api
BuildRequires:  jbossweb-jsp-2.1-api
BuildRequires:  jbossweb-servlet-2.5-api
BuildRequires:  jboss-messaging >= 0:1.4.3
BuildRequires:  jboss-integration >= 5.1.0
BuildRequires:  sun-fi >= 0:1.2.2
BuildRequires:  jboss-cl >= 0:2.0.6
BuildRequires:  jcommon >= 0:1.0.16
#BuildRequires:  jboss-xnio-base >= 0:1.2.1
BuildRequires:  jboss-xnio-base >= 0:1.2.0
BuildRequires:  jboss-xnio-metadata >= 0:1.0.1
BuildRequires:  hibernate3-commons-annotations >= 0:3.1.0
BuildRequires:  jbossws >= 0:3.1.2
BuildRequires:  jbossws-framework >= 0:3.1.2
BuildRequires:  jbossxb2 >= 0:2.0.1
BuildRequires:  quartz >= 0:1.5.2
BuildRequires:  xml-security >= 0:1.4.2
BuildRequires:  jboss-metadata >= 0:1.0.1
BuildRequires:  jboss-ejb3-common >= 0:1.0.0
#BuildRequires:  jboss-ejb3-as-int >= 0:1.0.17
BuildRequires:  jboss-ejb3-as-int >= 0:1.1.5
BuildRequires:  jboss-ejb3-core >= 0:1.1.5
BuildRequires:  jboss-ejb3-proxy-impl >= 0:1.0.2
BuildRequires:  jboss-ejb3-proxy-spi >= 0:1.0.0
BuildRequires:  jboss-ejb3-proxy-clustered >= 0:1.0.1
BuildRequires:  jboss-ejb3-security >= 0:1.0.0
##BuildRequires:  jboss-ejb3-metrics-deployer >= 0:1.0.1
BuildRequires:  jboss-ejb3-endpoint-deployer >= 0:0.1.4
# The ejb3 one below is probably an indirect dependency
#BuildRequires:  jboss-ejb3-deployers >= 0:1.0.1
BuildRequires:  jboss-logmanager >= 0:1.0.0
BuildRequires:  jettison >= 0:1.1
BuildRequires:  junit >= 0:3.8.2
BuildRequires:  spring2-webmvc >= 0:1.5.6
BuildRequires:  glassfish-jaxb >= 0:2.1.9
#BuildRequires:  myfaces >= 0:1.1.3
BuildRequires:  myfaces >= 0:1.1.0
BuildRequires:  jboss-jaspi-1.0-api >= 0:5.0.1
BuildRequires:  jacorb-jboss >= 0:2.3.0
BuildRequires:  jfreechart >= 0:1.0.13
BuildRequires:  hibernate3-ejb-persistence-3.0-api >= 1:1.0.2
BuildRequires:  jboss-cluster-ha-server-cache-spi >= 0:2.0.0
BuildRequires:  jboss-cache-pojo >= 0:3.0.0
BuildRequires:  jboss-microcontainer2 >= 0:2.0.8
BuildRequires:  glassfish-jsf >= 0:1.2_12
BuildRequires:  jboss-common-logging-spi >= 0:2.1.0
BuildRequires:  jboss-ejb-3.0-api >= 0:5.0.1
BuildRequires:  jboss-transaction-1.0.1-api >= 0:5.0.1
BuildRequires:  jboss-integration >= 0:5.1.0
BuildRequires:  jboss-reflect >= 0:2.0.2
BuildRequires:  jboss-profiler >= 0:1.0.0
BuildRequires:  jaxbintros >= 0:1.0.0
BuildRequires:  javassist >= 0:3.9.0
BuildRequires:  jakarta-commons-el >= 0:1.0
BuildRequires:  jakarta-commons-fileupload >= 0:1.1.1
BuildRequires:  jboss-bootstrap  >= 0:1.0.0
BuildRequires:  excalibur-avalon-logkit >= 0:2.2.1
BuildRequires:  excalibur-avalon-framework >= 0:4.3.1
BuildRequires:  tomcat6-el-1.0-api >= 0:6.0.18
BuildRequires:  jboss-test >= 0:1.1.4
BuildRequires:  jboss-man >= 0:2.1.0
BuildRequires:  opensaml >= 0:1.1b
BuildRequires:  jboss-remoting-aspects >= 0:1.0.1
BuildRequires:  jbosssx2 >= 0:2.0.3.1
BuildRequires:  velocity-jboss >= 0:1.4
BuildRequires:  xalan-j2 >= 0:2.7.1
# FIXME: we are using some sun-jaxws binaries bundled with this package:
BuildRequires:  glassfish-jaxws >= 0:2.1.3
BuildRequires:  spring2-beans >= 0:2.5.6
BuildRequires:  gnu-getopt >= 0:1.0.13
BuildRequires:  hibernate3-annotations >= 0:3.4.0
BuildRequires:  jboss-cache-core >= 0:3.1.0
BuildRequires:  easymock2 >= 0:2.4
#BuildRequires:  ws-scout >= 1.1.1
BuildRequires:  ws-scout0 >= 0:0.7
BuildRequires:  spring2-context >= 0:2.5.6
#BuildRequires:  jboss-cluster-ha-server-cache-jbc >= 0:2.0.1
BuildRequires:  jboss-cluster-ha-server-cache-jbc >= 0:2.0.0
BuildRequires:  jboss-naming >= 0:5.0.3
BuildRequires:  hsqldb >= 0:1.8.0.8
BuildRequires:  jboss-mdr >= 0:2.0.1
BuildRequires:  jakarta-slide-webdavclient >= 0:2.1
BuildRequires:  jboss-vfs2 >= 0:2.1.2
BuildRequires:  jboss-logbridge >= 0:1.0.0
BuildRequires:  ant-junit >= 0:1.7.1
BuildRequires:  jboss-security-spi >= 0:2.0.3
BuildRequires:  jboss-security-xacml >= 0:2.0.3
BuildRequires:  concurrent >= 0:1.3.4
BuildRequires:  jboss-jca-1.5-api >= 0:5.0.1
BuildRequires:  jboss-common-core >= 0:2.2.14
BuildRequires:  jboss-threads >= 0:1.0.0
BuildRequires:  jboss-jacc-1.1-api >= 0:5.0.1
BuildRequires:  xerces-j2 >= 0:2.9.1
BuildRequires:  jboss-transaction-aspects >= 0:1.0.0
BuildRequires:  dtdparser >= 0:1.2.1
BuildRequires:  juddi >= 0:0.9
BuildRequires:  odmg >= 0:3.0
BuildRequires:  jakarta-commons-discovery >= 0:0.4
BuildRequires:  hibernate3-validator >= 0:3.1.0
BuildRequires:  gnu-trove >= 0:1.0.2
BuildRequires:  bsf >= 0:2.4.0
BuildRequires:  spring2-web >= 0:2.5.6
BuildRequires:  jboss-remoting >= 0:2.5.1
BuildRequires:  jboss-serialization >= 0:1.0.3
BuildRequires:  objectweb-asm >= 0:3.1
BuildRequires:  joramtests >= 0:1.5
BuildRequires:  spring2-aop >= 0:2.5.6
BuildRequires:  joesnmp >= 0:0.3.4
BuildRequires:  cglib >= 0:2.2
BuildRequires:  slf4j >= 0:1.5.8
BuildRequires:  wstx >= 0:3.2.8
BuildRequires:  jgroups >= 0:2.6.12
BuildRequires:  wsdl4j >= 0:1.6.2
BuildRequires:  hibernate3-entitymanager >= 0:3.4.0
BuildRequires:  jboss-jad-1.2-api >= 0:5.0.1
BuildRequires:  spring2-core >= 0:2.5.6
BuildRequires:  jakarta-commons-httpclient >= 0:3.1
BuildRequires:  xml-commons-jaxp-1.3-apis >= 0:1.3.04
BuildRequires:  aopalliance >= 0:1.0
BuildRequires:  tjws >= 0:1.3.3
BuildRequires:  jboss5-libs >= 0:5.1.0
BuildRequires:  slf4j-jboss-logging >= 0:1.0.2
BuildRequires:  snmptrapappender >= 0:1.2.8
BuildRequires:  codehaus-stax11-api >= 0:1.1.2
BuildRequires:  jboss-common-logging-jdk >= 0:2.1.0
BuildRequires:  jboss-security-aspects >= 0:1.0.0
BuildRequires:  ws-jaxme-jboss >= 0:0.2
BuildRequires:  jcip-annotations >= 0:1.0
BuildRequires:  xml-commons-resolver11 >= 0:1.1
BuildRequires:  berkeleydb-je3 >= 0:3.0.12
BuildRequires:  jboss-jaxr >= 0:1.2.1
BuildRequires:  jboss-security-negotiation >= 0:2.0.3
BuildRequires:  jboss-seam-int >= 0:5.1.0
BuildRequires:  jms-integration-tests >= 0:1.0.1
BuildRequires:  felix-osgi-core >= 0:1.0
BuildRequires:  felix-osgi-compendium >= 0:1.0
BuildRequires:  jboss-ejb3 >= 0:1.1.6
BuildRequires:  jboss-ejb3-build
BuildRequires:  jboss-cluster-build
BuildRequires:  jboss-el >= 0:1.0_02-0.CR5
BuildRequires:  mojo-maven2-plugin-jboss-packaging
BuildRequires:  webbeans-jboss-int >= 0:5.2.0-0.1.Beta2
BuildRequires:  jboss-aspects-build
BuildRequires:  ws-commons-policy
BuildRequires:  zip

Requires:       jpackage-utils

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss AS Third-Party Libraries.

%prep
%setup -q -n jboss-%{namedversion}-src
%setup -q -T -D -a 17 -n jboss-%{namedversion}-src/%{namedversion}/jboss-%{majmin}.x
%setup -q -T -D -n jboss-%{namedversion}-src

%{_bindir}/find -type f -name "*.?ar" | %{_bindir}/xargs -t %{__rm}

# Here we apply the patches
pushd %{namedversion}/jboss-%{majmin}.x
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
popd

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
# Needed by the mvn-jpp command we use
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}

mkdir -p ${MAVEN_REPO_LOCAL}/javax/security/jaas/1.0.01
ln -sf %{java_home}/jre/lib/rt.jar ${MAVEN_REPO_LOCAL}/javax/security/jaas/1.0.01/jaas-1.0.01.jar

# Add any artifacts we cannot download to local repository
pushd ${MAVEN_REPO_LOCAL}
tar xf %{SOURCE13}
tar xf %{SOURCE16}
tar xf %{SOURCE17}
popd

# The depmap is used by the mvn-jpp command to convert dependencies
# to the locations and versions that are available (if needed)
cp -p %{SOURCE1} %{name}-depmap.xml
export MAVEN_DEPMAP=$(pwd)/%{name}-depmap.xml
export M2SETTINGS=$(pwd)/maven2-settings.xml

pushd %{namedversion}/jboss-%{majmin}.x
pushd thirdparty
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=${MAVEN_DEPMAP} \
        dependency:tree

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=${MAVEN_DEPMAP} \
        generate-resources
popd
popd

%install
rm -rf %{buildroot}
echo $(pwd)

# Create the ZIP
pushd %{namedversion}/jboss-%{majmin}.x
zip -q -9 -r jbossas-thirdparty.zip thirdparty
install -d -m 755 %{buildroot}%{_javadir}/jbossas-fordev
install -p -m 644 jbossas-thirdparty.zip %{buildroot}%{_javadir}/jbossas-fordev/%{name}-%{version}-%{release}.zip
popd

%clean
rm -rf ${buildroot}

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/jbossas-fordev
%{_javadir}/jbossas-fordev/%{name}-%{version}-%{release}.zip

%changelog
* Mon Feb 21 2011 David Walluck <dwalluck@redhat.com> 0:5.1.0-8
- rebuild for fixed webbeans-jboss-int

* Mon Feb 21 2011 David Walluck <dwalluck@redhat.com> 0:5.1.0-7
- use wsdl4j, not wsdl4j16
- BuildRequires: webbeans-jboss-int >= 0:5.2.0-0.1.Beta2

* Sat Feb 12 2011 David Walluck <dwalluck@redhat.com> 0:5.1.0-6
- remove bundled jars from source before building
- remove bundled jbossas-tp-jms-integration-tests.tgz
- remove bundled jbossas-tp-osgi.tgz
- BuildRequires: jms-integration-tests >= 0:1.0.1
- BuildRequires: felix-osgi-core >= 0:1.0, felix-osgi-compendium >= 0:1.0
- BuildRequires: jboss-el >= 0:1.0_02-0.CR5
- BuildRequires: jboss-ejb3 >= 0:1.1.6, jboss-ejb3-build
- add jpp depmap entry for annotation_1_0_api

* Wed Sep 29 2010 David Walluck <dwalluck@redhat.com> 0:5.1.0-5
- use wsdl4j16

* Thu Sep 23 2010 David Walluck <dwalluck@redhat.com> 0:5.1.0-4
- set sun-fi version to 1.2.2 (down from 1.2.7)

* Thu Sep 16 2010 David Walluck <dwalluck@redhat.com> 0:5.1.0-3
- Requires: jpackage-utils

* Tue Sep 14 2010 David Walluck <dwalluck@redhat.com> 0:5.1.0-2
- add URL
- add %%clean section

* Thu Mar 31 2010 David Walluck <dwalluck@redhat.com> 0:5.1.0-1
- release
